Prepare a drill suite from immutable repository revisions
curl --request POST \
--url https://api.firedrill.run/v1/ci/suites \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"kind": "github_invocation"
}
'import requests
url = "https://api.firedrill.run/v1/ci/suites"
payload = { "kind": "github_invocation" }
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({kind: 'github_invocation'})
};
fetch('https://api.firedrill.run/v1/ci/suites', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"schemaVersion": 1,
"ciSuiteId": "<string>",
"organizationId": "<string>",
"projectId": "<string>",
"environmentId": "<string>",
"repositoryBindingId": "<string>",
"credentialId": "<string>",
"provider": "github_actions",
"suiteKey": "<string>",
"source": {
"kind": "single_revision",
"candidateRevision": "<string>"
},
"evidenceUrl": "<string>",
"state": "preparing",
"builds": [
{
"schemaVersion": 1,
"side": "baseline",
"revision": "<string>",
"state": "queued",
"buildAttemptId": "<string>",
"updatedAtMs": 0,
"buildHash": "<string>",
"failure": {
"schemaVersion": 1,
"code": "<string>",
"source": "framework",
"message": "<string>",
"retryable": true,
"issues": [],
"correlationId": "<string>",
"details": {},
"evidence": {
"runId": "<string>",
"sequence": 4503599627370495
}
}
}
],
"counts": {
"logicalCases": 0,
"attemptCases": 0,
"pending": 0,
"active": 0,
"passed": 0,
"failed": 0,
"inconclusive": 0,
"error": 0,
"cancelled": 0
},
"version": 0,
"createdAtMs": 0,
"updatedAtMs": 0,
"ciInvocationId": "<string>",
"cancellationReason": "<string>",
"conclusion": "passed",
"result": {
"schemaVersion": 1,
"ciSuiteId": "<string>",
"conclusion": "passed",
"durationMs": 0,
"gate": {
"blockingClassifications": [
"contract"
],
"candidate": {
"logicalCases": 0,
"passed": 0,
"failed": 0,
"inconclusive": 0,
"error": 0,
"cancelled": 0
},
"blocksMerge": true,
"reason": "passed"
},
"summaries": [
{
"logicalCases": 0,
"passed": 0,
"failed": 0,
"inconclusive": 0,
"error": 0,
"cancelled": 0,
"side": "baseline",
"classification": "contract",
"attemptCases": 0,
"observedSamples": 0,
"passRate": 0.5,
"confidence95": {
"method": "wilson",
"lower": 0.5,
"upper": 0.5
},
"timing": {
"measuredRuns": 4503599627370495,
"meanMs": 1,
"p50Ms": 1,
"p95Ms": 1
}
}
],
"comparisons": {
"totalPairs": 0,
"inspectedPairs": 0,
"changedPairs": 0,
"unchangedPairs": 0,
"notComparablePairs": 0,
"uninspectedPairs": 0,
"inspectionErrors": 0,
"details": [
{
"drillId": "<string>",
"trial": 5000,
"seed": "<string>",
"baseline": {
"hostedRunId": "<string>",
"evidenceBundleId": "<string>",
"revision": "<string>",
"attempt": 5,
"outcome": "passed",
"durationMs": 0
},
"candidate": {
"hostedRunId": "<string>",
"evidenceBundleId": "<string>",
"revision": "<string>",
"attempt": 5,
"outcome": "passed",
"durationMs": 0
},
"compatibility": {
"status": "exact_inputs",
"canAttributeBehaviorChange": true,
"differences": [
"drill"
],
"explanation": "<string>"
},
"outcome": "changed",
"timing": {
"baselineMs": 0,
"candidateMs": 0,
"deltaMs": 0
},
"changes": {
"verdictChanged": true,
"operationCounts": {
"total": 0,
"items": [
{
"subject": "<string>",
"baseline": 0,
"candidate": 0,
"delta": 0,
"baselineErrors": 0,
"candidateErrors": 0
}
],
"omitted": 0
},
"stateChangeCounts": {
"total": 0,
"items": [
{
"subject": "<string>",
"baseline": 0,
"candidate": 0,
"delta": 0
}
],
"omitted": 0
},
"eventCounts": {
"total": 0,
"items": [
{
"subject": "<string>",
"baseline": 0,
"candidate": 0,
"delta": 0
}
],
"omitted": 0
},
"assertions": {
"total": 0,
"items": [
{
"checkpointId": "<string>",
"assertionId": "<string>",
"actualChanged": true,
"baseline": "passed",
"candidate": "passed",
"expectedChanged": true
}
],
"omitted": 0
},
"interactions": {
"total": 0,
"items": [
{
"interactionId": "<string>",
"baseline": "<string>",
"candidate": "<string>"
}
],
"omitted": 0
},
"stateChanged": true,
"trajectoryChanged": true
}
}
],
"omittedDetails": 0
}
},
"githubReviewDelivery": {
"schemaVersion": 1,
"state": "pending",
"commentExpected": true,
"attempts": 50,
"createdAtMs": 0,
"updatedAtMs": 0,
"checkRunId": "<string>",
"checkUrl": "<string>",
"commentId": "<string>",
"commentUrl": "<string>",
"lastErrorCode": "<string>",
"finishedAtMs": 0
},
"policy": {
"schemaVersion": 1,
"sourceSide": "baseline",
"sourceBuildHash": "<string>",
"suiteKey": "<string>",
"concurrency": 32,
"drills": [
{
"drillId": "<string>",
"targetId": "<string>",
"classification": "contract",
"trials": 5000,
"retries": 5,
"timeoutMs": 43200000
}
],
"logicalCases": 5000
},
"failure": {
"schemaVersion": 1,
"code": "<string>",
"source": "framework",
"message": "<string>",
"retryable": true,
"issues": [],
"correlationId": "<string>",
"details": {},
"evidence": {
"runId": "<string>",
"sequence": 4503599627370495
}
},
"finishedAtMs": 0
}{
"schemaVersion": 1,
"ciSuiteId": "<string>",
"organizationId": "<string>",
"projectId": "<string>",
"environmentId": "<string>",
"repositoryBindingId": "<string>",
"credentialId": "<string>",
"provider": "github_actions",
"suiteKey": "<string>",
"source": {
"kind": "single_revision",
"candidateRevision": "<string>"
},
"evidenceUrl": "<string>",
"state": "preparing",
"builds": [
{
"schemaVersion": 1,
"side": "baseline",
"revision": "<string>",
"state": "queued",
"buildAttemptId": "<string>",
"updatedAtMs": 0,
"buildHash": "<string>",
"failure": {
"schemaVersion": 1,
"code": "<string>",
"source": "framework",
"message": "<string>",
"retryable": true,
"issues": [],
"correlationId": "<string>",
"details": {},
"evidence": {
"runId": "<string>",
"sequence": 4503599627370495
}
}
}
],
"counts": {
"logicalCases": 0,
"attemptCases": 0,
"pending": 0,
"active": 0,
"passed": 0,
"failed": 0,
"inconclusive": 0,
"error": 0,
"cancelled": 0
},
"version": 0,
"createdAtMs": 0,
"updatedAtMs": 0,
"ciInvocationId": "<string>",
"cancellationReason": "<string>",
"conclusion": "passed",
"result": {
"schemaVersion": 1,
"ciSuiteId": "<string>",
"conclusion": "passed",
"durationMs": 0,
"gate": {
"blockingClassifications": [
"contract"
],
"candidate": {
"logicalCases": 0,
"passed": 0,
"failed": 0,
"inconclusive": 0,
"error": 0,
"cancelled": 0
},
"blocksMerge": true,
"reason": "passed"
},
"summaries": [
{
"logicalCases": 0,
"passed": 0,
"failed": 0,
"inconclusive": 0,
"error": 0,
"cancelled": 0,
"side": "baseline",
"classification": "contract",
"attemptCases": 0,
"observedSamples": 0,
"passRate": 0.5,
"confidence95": {
"method": "wilson",
"lower": 0.5,
"upper": 0.5
},
"timing": {
"measuredRuns": 4503599627370495,
"meanMs": 1,
"p50Ms": 1,
"p95Ms": 1
}
}
],
"comparisons": {
"totalPairs": 0,
"inspectedPairs": 0,
"changedPairs": 0,
"unchangedPairs": 0,
"notComparablePairs": 0,
"uninspectedPairs": 0,
"inspectionErrors": 0,
"details": [
{
"drillId": "<string>",
"trial": 5000,
"seed": "<string>",
"baseline": {
"hostedRunId": "<string>",
"evidenceBundleId": "<string>",
"revision": "<string>",
"attempt": 5,
"outcome": "passed",
"durationMs": 0
},
"candidate": {
"hostedRunId": "<string>",
"evidenceBundleId": "<string>",
"revision": "<string>",
"attempt": 5,
"outcome": "passed",
"durationMs": 0
},
"compatibility": {
"status": "exact_inputs",
"canAttributeBehaviorChange": true,
"differences": [
"drill"
],
"explanation": "<string>"
},
"outcome": "changed",
"timing": {
"baselineMs": 0,
"candidateMs": 0,
"deltaMs": 0
},
"changes": {
"verdictChanged": true,
"operationCounts": {
"total": 0,
"items": [
{
"subject": "<string>",
"baseline": 0,
"candidate": 0,
"delta": 0,
"baselineErrors": 0,
"candidateErrors": 0
}
],
"omitted": 0
},
"stateChangeCounts": {
"total": 0,
"items": [
{
"subject": "<string>",
"baseline": 0,
"candidate": 0,
"delta": 0
}
],
"omitted": 0
},
"eventCounts": {
"total": 0,
"items": [
{
"subject": "<string>",
"baseline": 0,
"candidate": 0,
"delta": 0
}
],
"omitted": 0
},
"assertions": {
"total": 0,
"items": [
{
"checkpointId": "<string>",
"assertionId": "<string>",
"actualChanged": true,
"baseline": "passed",
"candidate": "passed",
"expectedChanged": true
}
],
"omitted": 0
},
"interactions": {
"total": 0,
"items": [
{
"interactionId": "<string>",
"baseline": "<string>",
"candidate": "<string>"
}
],
"omitted": 0
},
"stateChanged": true,
"trajectoryChanged": true
}
}
],
"omittedDetails": 0
}
},
"githubReviewDelivery": {
"schemaVersion": 1,
"state": "pending",
"commentExpected": true,
"attempts": 50,
"createdAtMs": 0,
"updatedAtMs": 0,
"checkRunId": "<string>",
"checkUrl": "<string>",
"commentId": "<string>",
"commentUrl": "<string>",
"lastErrorCode": "<string>",
"finishedAtMs": 0
},
"policy": {
"schemaVersion": 1,
"sourceSide": "baseline",
"sourceBuildHash": "<string>",
"suiteKey": "<string>",
"concurrency": 32,
"drills": [
{
"drillId": "<string>",
"targetId": "<string>",
"classification": "contract",
"trials": 5000,
"retries": 5,
"timeoutMs": 43200000
}
],
"logicalCases": 5000
},
"failure": {
"schemaVersion": 1,
"code": "<string>",
"source": "framework",
"message": "<string>",
"retryable": true,
"issues": [],
"correlationId": "<string>",
"details": {},
"evidence": {
"runId": "<string>",
"sequence": 4503599627370495
}
},
"finishedAtMs": 0
}{
"code": "<string>",
"message": "<string>",
"correlationId": "<string>",
"retryable": true,
"source": "platform",
"retryAfterMs": 123,
"operationId": "<string>",
"issues": [
{
"path": "<string>",
"code": "<string>",
"message": "<string>"
}
],
"details": {},
"evidence": {
"sessionId": "<string>",
"runId": "<string>",
"journalSeq": 4503599627370495,
"buildHash": "<string>"
}
}Prepare a drill suite from immutable repository revisions
Prepare a drill suite from immutable repository revisions
Authorizations
Opaque control credential
Headers
Required string length:
8 - 128Pattern:
^[A-Za-z0-9._:-]+$Body
application/json
- Option 1
- Option 2
Available options:
github_invocation Response
Idempotent replay of the existing suite
Available options:
1 Pattern:
^cisuite_[0-9a-z]{12,32}$Pattern:
^org_[0-9a-z]{12,32}$Pattern:
^prj_[0-9a-z]{12,32}$Pattern:
^env_[0-9a-z]{12,32}$Pattern:
^repo_[0-9a-z]{12,32}$Pattern:
^cred_[0-9a-z]{12,32}$Available options:
github_actions, service Required string length:
1 - 96Pattern:
^[A-Za-z0-9][A-Za-z0-9._-]*$- Option 1
- Option 2
Show child attributes
Show child attributes
Maximum string length:
2048Available options:
preparing, running, cancelling, completed, failed, cancelled Required array length:
1 - 2 elementsShow child attributes
Show child attributes
Show child attributes
Show child attributes
Required range:
-9007199254740991 <= x <= 9007199254740991Required range:
-9007199254740991 <= x <= 9007199254740991Required range:
-9007199254740991 <= x <= 9007199254740991Pattern:
^ci_[0-9a-z]{12,32}$Required string length:
1 - 1000Available options:
passed, failed, inconclusive, error, cancelled Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Required range:
-9007199254740991 <= x <= 9007199254740991